Index: /palm/trunk/UTIL/inifor/src/inifor_io.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/inifor_io.f90	(revision 3865)
+++ /palm/trunk/UTIL/inifor/src/inifor_io.f90	(revision 3866)
@@ -630,34 +635,34 @@
 !> Abort INIFOR if the given file is not present.
 !------------------------------------------------------------------------------!
-   SUBROUTINE verify_file(file_name, file_kind, tip)
-
-      CHARACTER(LEN=*), INTENT(IN)           ::  file_name, file_kind
-      CHARACTER(LEN=*), INTENT(IN), OPTIONAL ::  tip
-
-      IF (.NOT. file_present(file_name))  THEN
-
-         IF (LEN(TRIM(file_name)) == 0)  THEN
-
-            message = "No name was given for the " // TRIM(file_kind) // " file."
-
-         ELSE
-
-            message = "The " // TRIM(file_kind) // " file '" //                &
-                      TRIM(file_name) // "' was not found."
-
-            IF (PRESENT(tip))  THEN
-               message = TRIM(message) // " " // TRIM(tip)
-            ENDIF
-
-         ENDIF
-
-         CALL inifor_abort('verify_file', message)
-
-      ENDIF
-
-      message = "Set up input file name '" // TRIM(file_name) // "'"
-      CALL report('verify_file', message)
-
-   END SUBROUTINE verify_file
+ SUBROUTINE verify_file(file_name, file_kind, tip)
+
+    CHARACTER(LEN=*), INTENT(IN)           ::  file_name, file_kind
+    CHARACTER(LEN=*), INTENT(IN), OPTIONAL ::  tip
+
+    IF (.NOT. file_present(file_name))  THEN
+
+       IF (LEN(TRIM(file_name)) == 0)  THEN
+
+          message = "No name was given for the " // TRIM(file_kind) // " file."
+
+       ELSE
+
+          message = "The " // TRIM(file_kind) // " file '" //                &
+                    TRIM(file_name) // "' was not found."
+
+          IF (PRESENT(tip))  THEN
+             message = TRIM(message) // " " // TRIM(tip)
+          ENDIF
+
+       ENDIF
+
+       CALL inifor_abort('verify_file', message)
+
+    ENDIF
+
+    message = "Set up input file name '" // TRIM(file_name) // "'"
+    CALL report('verify_file', message)
+
+ END SUBROUTINE verify_file
 
 
@@ -668,12 +673,12 @@
 !> i+1 of the argument list.
 !------------------------------------------------------------------------------!
-   SUBROUTINE get_option_argument(i, arg)
-      CHARACTER(LEN=PATH), INTENT(INOUT) ::  arg
-      INTEGER, INTENT(INOUT)             ::  i
-
-      i = i + 1
-      CALL GET_COMMAND_ARGUMENT(i, arg)
-
-   END SUBROUTINE
+ SUBROUTINE get_option_argument(i, arg)
+    CHARACTER(LEN=PATH), INTENT(INOUT) ::  arg
+    INTEGER, INTENT(INOUT)             ::  i
+
+    i = i + 1
+    CALL GET_COMMAND_ARGUMENT(i, arg)
+
+ END SUBROUTINE
 
 
@@ -683,147 +688,146 @@
 !> Checks the INIFOR configuration 'cfg' for plausibility.
 !------------------------------------------------------------------------------!
-   SUBROUTINE validate_config(cfg)
-      TYPE(inifor_config), INTENT(IN) ::  cfg
-
-      CALL verify_file(cfg % hhl_file, 'HHL')
-      CALL verify_file(cfg % namelist_file, 'NAMELIST')
-      CALL verify_file(cfg % soiltyp_file, 'SOILTYP')
-
-!
-!--   Only check optional static driver file name, if it has been given.
-      IF (TRIM(cfg % static_driver_file) .NE. '')  THEN
-         CALL verify_file(cfg % static_driver_file, 'static driver')
-      ENDIF
-
-      SELECT CASE( TRIM(cfg % ic_mode) )
-      CASE( 'profile', 'volume')
-      CASE DEFAULT
-         message = "Initialization mode '" // TRIM(cfg % ic_mode) //&
-                   "' is not supported. " //&
-                   "Please select either 'profile' or 'volume', " //&
-                   "or omit the -i/--init-mode/-mode option entirely, which corresponds "//&
-                   "to the latter."
-         CALL inifor_abort( 'validate_config', message )
-      END SELECT
-
-
-      SELECT CASE( TRIM(cfg % bc_mode) )
-      CASE( 'real', 'ideal')
-      CASE DEFAULT
-         message = "Forcing mode '" // TRIM(cfg % bc_mode) //& 
-                   "' is not supported. " //&
-                   "Please select either 'real' or 'ideal', " //&
-                   "or omit the -f/--forcing-mode option entirely, which corresponds "//&
-                   "to the latter."
-         CALL inifor_abort( 'validate_config', message )
-      END SELECT
-
-      SELECT CASE( TRIM(cfg % averaging_mode) )
-      CASE( 'level' )
-      CASE( 'height' )
-         message = "Averaging mode '" // TRIM(cfg % averaging_mode) //&
-                   "' is currently not supported. " //&
-                   "Please use level-based averaging by selecting 'level', " //&
-                   "or by omitting the --averaging-mode option entirely."
-         CALL inifor_abort( 'validate_config', message )
-      CASE DEFAULT
-         message = "Averaging mode '" // TRIM(cfg % averaging_mode) //&
-                   "' is not supported. " //&
-         !          "Please select either 'height' or 'level', " //&
-         !          "or omit the --averaging-mode option entirely, which corresponds "//&
-         !          "to the latter."
-                   "Please use level-based averaging by selecting 'level', " //&
-                   "or by omitting the --averaging-mode option entirely."
-         CALL inifor_abort( 'validate_config', message )
-      END SELECT
-
-      IF ( cfg % ug_defined_by_user .NEQV. cfg % vg_defined_by_user )  THEN
-         message = "You specified only one component of the geostrophic " // &
-                   "wind. Please specify either both or none."
-         CALL inifor_abort( 'validate_config', message )
-      ENDIF
-
-   END SUBROUTINE validate_config
-
-
-   SUBROUTINE get_cosmo_grid( cfg, soil_file, rlon, rlat, hhl, hfl, depths, &
-                              d_depth, d_depth_rho_inv, phi_n, lambda_n,       &
-                              phi_equat,                                       &
-                              lonmin_cosmo, lonmax_cosmo,                      &
-                              latmin_cosmo, latmax_cosmo,                      &
-                              nlon, nlat, nlev, ndepths )
-
-      TYPE(inifor_config), INTENT(IN)                      ::  cfg
-      CHARACTER(LEN=PATH), INTENT(IN)                      ::  soil_file !< list of soil input files (temperature, moisture, <prefix>YYYYMMDDHH-soil.nc)
-      REAL(dp), DIMENSION(:), ALLOCATABLE, INTENT(OUT)     ::  rlon      !< longitudes of COSMO-DE's rotated-pole grid
-      REAL(dp), DIMENSION(:), ALLOCATABLE, INTENT(OUT)     ::  rlat      !< latitudes of COSMO-DE's rotated-pole grid
-      REAL(dp), DIMENSION(:,:,:), ALLOCATABLE, INTENT(OUT) ::  hhl       !< heights of half layers (cell faces) above sea level in COSMO-DE, read in from external file
-      REAL(dp), DIMENSION(:,:,:), ALLOCATABLE, INTENT(OUT) ::  hfl       !< heights of full layers (cell centres) above sea level in COSMO-DE, computed as arithmetic average of hhl
-      REAL(dp), DIMENSION(:), ALLOCATABLE, INTENT(OUT)     ::  depths    !< COSMO-DE's TERRA-ML soil layer depths
-      REAL(dp), DIMENSION(:), ALLOCATABLE, INTENT(OUT)     ::  d_depth
-      REAL(dp), DIMENSION(:), ALLOCATABLE, INTENT(OUT)     ::  d_depth_rho_inv
-      REAL(dp), INTENT(OUT)                                ::  phi_n
-      REAL(dp), INTENT(OUT)                                ::  phi_equat
-      REAL(dp), INTENT(OUT)                                ::  lambda_n
-      REAL(dp), INTENT(OUT)                                ::  lonmin_cosmo !< Minimunm longitude of COSMO-DE's rotated-pole grid [COSMO rotated-pole rad]
-      REAL(dp), INTENT(OUT)                                ::  lonmax_cosmo !< Maximum longitude of COSMO-DE's rotated-pole grid [COSMO rotated-pole rad]
-      REAL(dp), INTENT(OUT)                                ::  latmin_cosmo !< Minimunm latitude of COSMO-DE's rotated-pole grid [COSMO rotated-pole rad]
-      REAL(dp), INTENT(OUT)                                ::  latmax_cosmo !< Maximum latitude of COSMO-DE's rotated-pole grid [COSMO rotated-pole rad]
-      INTEGER, INTENt(OUT)                                 ::  nlon, nlat, nlev, ndepths
-
-      TYPE(nc_var) ::  cosmo_var !< COSMO dummy variable, used for reading HHL, rlon, rlat
-      INTEGER      ::  k
-
-!
-!--   Read in COSMO's heights of half layers (vertical cell faces)
-      cosmo_var % name = NC_HHL_NAME
-      CALL get_netcdf_variable( cfg % hhl_file, cosmo_var, hhl )
-      CALL get_netcdf_dim_vector( cfg % hhl_file, NC_RLON_NAME, rlon )
-      CALL get_netcdf_dim_vector( cfg % hhl_file, NC_RLAT_NAME, rlat )
-      CALL get_netcdf_dim_vector( soil_file, NC_DEPTH_NAME, depths)
- CALL run_control( 'time', 'read' )
-
-      CALL reverse( hhl )
-      nlon = SIZE( hhl, 1 )
-      nlat = SIZE( hhl, 2 )
-      nlev = SIZE( hhl, 3 )
-      ndepths = SIZE( depths )
-
- CALL run_control( 'time', 'comp' )
-
-      ALLOCATE( hfl( nlon, nlat, nlev-1 ) )
-      ALLOCATE( d_depth( ndepths ), d_depth_rho_inv( ndepths ) )
- CALL run_control('time', 'alloc')
-
-      CALL get_soil_layer_thickness( depths, d_depth )
-      d_depth_rho_inv = 1.0_dp / ( d_depth * RHO_L )
-
-!
-!--   Compute COSMO's heights of full layers (cell centres)
-      DO k = 1, nlev-1
-         hfl(:,:,k) = 0.5_dp * ( hhl(:,:,k) +                                  &
-                                 hhl(:,:,k+1) )
-      ENDDO
-!
-!--   COSMO rotated pole coordinates
-      phi_n = TO_RADIANS                                                       &
-            * get_netcdf_variable_attribute( cfg % hhl_file,                   &
-                                             NC_ROTATED_POLE_NAME,             &
-                                             NC_POLE_LATITUDE_NAME )
-
-      lambda_n = TO_RADIANS                                                    &
-               * get_netcdf_variable_attribute( cfg % hhl_file,                &
-                                                NC_ROTATED_POLE_NAME,          &
-                                                NC_POLE_LONGITUDE_NAME )
-
-      phi_equat = 90.0_dp * TO_RADIANS - phi_n
-
-      lonmin_cosmo = MINVAL( rlon ) * TO_RADIANS
-      lonmax_cosmo = MAXVAL( rlon ) * TO_RADIANS
-      latmin_cosmo = MINVAL( rlat ) * TO_RADIANS
-      latmax_cosmo = MAXVAL( rlat ) * TO_RADIANS
- CALL run_control('time', 'comp')
-
-   END SUBROUTINE get_cosmo_grid
+ SUBROUTINE validate_config(cfg)
+    TYPE(inifor_config), INTENT(IN) ::  cfg
+
+    CALL verify_file(cfg%hhl_file, 'HHL')
+    CALL verify_file(cfg%namelist_file, 'NAMELIST')
+    CALL verify_file(cfg%soiltyp_file, 'SOILTYP')
+
+!
+!-- Only check optional static driver file name, if it has been given.
+    IF (TRIM(cfg%static_driver_file) .NE. '')  THEN
+       CALL verify_file(cfg%static_driver_file, 'static driver')
+    ENDIF
+
+    SELECT CASE( TRIM(cfg%ic_mode) )
+       CASE( 'profile', 'volume')
+       CASE DEFAULT
+          message = "Initialization mode '" // TRIM(cfg%ic_mode) //&
+                    "' is not supported. " //&
+                    "Please select either 'profile' or 'volume', " //&
+                    "or omit the -i/--init-mode/-mode option entirely, which corresponds "//&
+                    "to the latter."
+          CALL inifor_abort( 'validate_config', message )
+    END SELECT
+
+    SELECT CASE( TRIM(cfg%bc_mode) )
+       CASE( 'real', 'ideal')
+       CASE DEFAULT
+          message = "Forcing mode '" // TRIM(cfg%bc_mode) //& 
+                    "' is not supported. " //&
+                    "Please select either 'real' or 'ideal', " //&
+                    "or omit the -f/--forcing-mode option entirely, which corresponds "//&
+                    "to the latter."
+          CALL inifor_abort( 'validate_config', message )
+    END SELECT
+
+    SELECT CASE( TRIM(cfg%averaging_mode) )
+       CASE( 'level' )
+       CASE( 'height' )
+          message = "Averaging mode '" // TRIM(cfg%averaging_mode) //&
+                    "' is currently not supported. " //&
+                    "Please use level-based averaging by selecting 'level', " //&
+                    "or by omitting the --averaging-mode option entirely."
+          CALL inifor_abort( 'validate_config', message )
+       CASE DEFAULT
+          message = "Averaging mode '" // TRIM(cfg%averaging_mode) //&
+                    "' is not supported. " //&
+          !          "Please select either 'height' or 'level', " //&
+          !          "or omit the --averaging-mode option entirely, which corresponds "//&
+          !          "to the latter."
+                    "Please use level-based averaging by selecting 'level', " //&
+                    "or by omitting the --averaging-mode option entirely."
+          CALL inifor_abort( 'validate_config', message )
+    END SELECT
+
+    IF ( cfg%ug_defined_by_user .NEQV. cfg%vg_defined_by_user )  THEN
+       message = "You specified only one component of the geostrophic " // &
+                 "wind. Please specify either both or none."
+       CALL inifor_abort( 'validate_config', message )
+    ENDIF
+
+ END SUBROUTINE validate_config
+
+
+ SUBROUTINE get_cosmo_grid( cfg, soil_file, rlon, rlat, hhl, hfl, depths, &
+                            d_depth, d_depth_rho_inv, phi_n, lambda_n,       &
+                            phi_equat,                                       &
+                            lonmin_cosmo, lonmax_cosmo,                      &
+                            latmin_cosmo, latmax_cosmo,                      &
+                            nlon, nlat, nlev, ndepths )
+
+    TYPE(inifor_config), INTENT(IN)                      ::  cfg
+    CHARACTER(LEN=PATH), INTENT(IN)                      ::  soil_file !< list of soil input files (temperature, moisture, <prefix>YYYYMMDDHH-soil.nc)
+    REAL(wp), DIMENSION(:), ALLOCATABLE, INTENT(OUT)     ::  rlon      !< longitudes of COSMO-DE's rotated-pole grid
+    REAL(wp), DIMENSION(:), ALLOCATABLE, INTENT(OUT)     ::  rlat      !< latitudes of COSMO-DE's rotated-pole grid
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, INTENT(OUT) ::  hhl       !< heights of half layers (cell faces) above sea level in COSMO-DE, read in from external file
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, INTENT(OUT) ::  hfl       !< heights of full layers (cell centres) above sea level in COSMO-DE, computed as arithmetic average of hhl
+    REAL(wp), DIMENSION(:), ALLOCATABLE, INTENT(OUT)     ::  depths    !< COSMO-DE's TERRA-ML soil layer depths
+    REAL(wp), DIMENSION(:), ALLOCATABLE, INTENT(OUT)     ::  d_depth
+    REAL(wp), DIMENSION(:), ALLOCATABLE, INTENT(OUT)     ::  d_depth_rho_inv
+    REAL(wp), INTENT(OUT)                                ::  phi_n
+    REAL(wp), INTENT(OUT)                                ::  phi_equat
+    REAL(wp), INTENT(OUT)                                ::  lambda_n
+    REAL(wp), INTENT(OUT)                                ::  lonmin_cosmo !< Minimunm longitude of COSMO-DE's rotated-pole grid [COSMO rotated-pole rad]
+    REAL(wp), INTENT(OUT)                                ::  lonmax_cosmo !< Maximum longitude of COSMO-DE's rotated-pole grid [COSMO rotated-pole rad]
+    REAL(wp), INTENT(OUT)                                ::  latmin_cosmo !< Minimunm latitude of COSMO-DE's rotated-pole grid [COSMO rotated-pole rad]
+    REAL(wp), INTENT(OUT)                                ::  latmax_cosmo !< Maximum latitude of COSMO-DE's rotated-pole grid [COSMO rotated-pole rad]
+    INTEGER, INTENt(OUT)                                 ::  nlon, nlat, nlev, ndepths
+
+    TYPE(nc_var) ::  cosmo_var !< COSMO dummy variable, used for reading HHL, rlon, rlat
+    INTEGER      ::  k
+
+!
+!-- Read in COSMO's heights of half layers (vertical cell faces)
+    cosmo_var%name = NC_HHL_NAME
+    CALL get_netcdf_variable( cfg%hhl_file, cosmo_var, hhl )
+    CALL get_netcdf_dim_vector( cfg%hhl_file, NC_RLON_NAME, rlon )
+    CALL get_netcdf_dim_vector( cfg%hhl_file, NC_RLAT_NAME, rlat )
+    CALL get_netcdf_dim_vector( soil_file, NC_DEPTH_NAME, depths)
+    CALL log_runtime( 'time', 'read' )
+
+    CALL reverse( hhl )
+    nlon = SIZE( hhl, 1 )
+    nlat = SIZE( hhl, 2 )
+    nlev = SIZE( hhl, 3 )
+    ndepths = SIZE( depths )
+
+    CALL log_runtime( 'time', 'comp' )
+
+    ALLOCATE( hfl( nlon, nlat, nlev-1 ) )
+    ALLOCATE( d_depth( ndepths ), d_depth_rho_inv( ndepths ) )
+    CALL log_runtime('time', 'alloc')
+
+    CALL get_soil_layer_thickness( depths, d_depth )
+    d_depth_rho_inv = 1.0_wp / ( d_depth * RHO_L )
+
+!
+!-- Compute COSMO's heights of full layers (cell centres)
+    DO  k = 1, nlev-1
+       hfl(:,:,k) = 0.5_wp * ( hhl(:,:,k) +                                  &
+                               hhl(:,:,k+1) )
+    ENDDO
+!
+!-- COSMO rotated pole coordinates
+    phi_n = TO_RADIANS                                                       &
+          * get_netcdf_variable_attribute( cfg%hhl_file,                   &
+                                           NC_ROTATED_POLE_NAME,             &
+                                           NC_POLE_LATITUDE_NAME )
+
+    lambda_n = TO_RADIANS                                                    &
+             * get_netcdf_variable_attribute( cfg%hhl_file,                &
+                                              NC_ROTATED_POLE_NAME,          &
+                                              NC_POLE_LONGITUDE_NAME )
+
+    phi_equat = 90.0_wp * TO_RADIANS - phi_n
+
+    lonmin_cosmo = MINVAL( rlon ) * TO_RADIANS
+    lonmax_cosmo = MAXVAL( rlon ) * TO_RADIANS
+    latmin_cosmo = MINVAL( rlat ) * TO_RADIANS
+    latmax_cosmo = MAXVAL( rlat ) * TO_RADIANS
+    CALL log_runtime('time', 'comp')
+
+ END SUBROUTINE get_cosmo_grid
 
 
@@ -856,13 +860,13 @@
 !>
 !------------------------------------------------------------------------------!
-    SUBROUTINE get_soil_layer_thickness(depths, d_depth)
-
-       REAL(dp), INTENT(IN)  ::  depths(:)
-       REAL(dp), INTENT(OUT) ::  d_depth(:)
-
-       d_depth(:) = depths(:)
-       d_depth(1) = 2.0_dp * depths(1)
-
-    END SUBROUTINE get_soil_layer_thickness
+ SUBROUTINE get_soil_layer_thickness(depths, d_depth)
+
+    REAL(wp), INTENT(IN)  ::  depths(:)
+    REAL(wp), INTENT(OUT) ::  d_depth(:)
+
+    d_depth(:) = depths(:)
+    d_depth(1) = 2.0_wp * depths(1)
+
+ END SUBROUTINE get_soil_layer_thickness
 !------------------------------------------------------------------------------!
 ! Description:
@@ -870,10 +874,10 @@
 !> Check whether the given file is present on the filesystem.
 !------------------------------------------------------------------------------!
-   LOGICAL FUNCTION file_present(filename)
-      CHARACTER(LEN=PATH), INTENT(IN) ::  filename
-
-      INQUIRE(FILE=filename, EXIST=file_present)
-
-   END FUNCTION file_present
+ LOGICAL FUNCTION file_present(filename)
+    CHARACTER(LEN=PATH), INTENT(IN) ::  filename
+
+    INQUIRE(FILE=filename, EXIST=file_present)
+
+ END FUNCTION file_present
 
 
@@ -888,29 +892,29 @@
 !> writes the actual data.
 !------------------------------------------------------------------------------!
-   SUBROUTINE setup_netcdf_dimensions(output_file, palm_grid,                  &
-                                      start_date_string, origin_lon, origin_lat)
-
-       TYPE(nc_file), INTENT(INOUT)      ::  output_file
-       TYPE(grid_definition), INTENT(IN) ::  palm_grid
-       CHARACTER (LEN=DATE), INTENT(IN)  ::  start_date_string
-       REAL(dp), INTENT(IN)              ::  origin_lon, origin_lat
-
-       CHARACTER (LEN=8)     ::  date_string
-       CHARACTER (LEN=10)    ::  time_string
-       CHARACTER (LEN=5)     ::  zone_string
-       CHARACTER (LEN=SNAME) ::  history_string
-       INTEGER               ::  ncid, nx, ny, nz, nt, dimids(3), dimvarids(3)
-       REAL(dp)              ::  z0
-
-       message = "Initializing PALM-4U dynamic driver file '" //               &
-                 TRIM(output_file % name) // "' and setting up dimensions."
-       CALL report('setup_netcdf_dimensions', message)
-
-!
-!--    Create the netCDF file as in netCDF-4/HDF5 format if __netcdf4 preprocessor flag is given
+ SUBROUTINE setup_netcdf_dimensions( output_file, palm_grid,                  &
+                                     start_date_string, origin_lon, origin_lat )
+
+    TYPE(nc_file), INTENT(INOUT)      ::  output_file
+    TYPE(grid_definition), INTENT(IN) ::  palm_grid
+    CHARACTER (LEN=DATE), INTENT(IN)  ::  start_date_string
+    REAL(wp), INTENT(IN)              ::  origin_lon, origin_lat
+
+    CHARACTER (LEN=8)     ::  date_string
+    CHARACTER (LEN=10)    ::  time_string
+    CHARACTER (LEN=5)     ::  zone_string
+    CHARACTER (LEN=SNAME) ::  history_string
+    INTEGER               ::  ncid, nx, ny, nz, nt, dimids(3), dimvarids(3)
+    REAL(wp)              ::  z0
+
+    message = "Initializing PALM-4U dynamic driver file '" //               &
+              TRIM(output_file%name) // "' and setting up dimensions."
+    CALL report('setup_netcdf_dimensions', message)
+
+!
+!-- Create the netCDF file as in netCDF-4/HDF5 format if __netcdf4 preprocessor flag is given
 #if defined( __netcdf4 )
-       CALL check(nf90_create(TRIM(output_file % name), OR(NF90_CLOBBER, NF90_HDF5), ncid))
+    CALL check(nf90_create(TRIM(output_file%name), OR(NF90_CLOBBER, NF90_HDF5), ncid))
 #else
-       CALL check(nf90_create(TRIM(output_file % name), NF90_CLOBBER, ncid))
+    CALL check(nf90_create(TRIM(output_file%name), NF90_CLOBBER, ncid))
 #endif
 
@@ -918,9 +922,9 @@
 !- Section 1: Define NetCDF dimensions and coordinates
 !------------------------------------------------------------------------------
-       nt = SIZE(output_file % time)
-       nx = palm_grid % nx
-       ny = palm_grid % ny
-       nz = palm_grid % nz
-       z0 = palm_grid % z0
+    nt = SIZE(output_file%time)
+    nx = palm_grid%nx
+    ny = palm_grid%ny
+    nz = palm_grid%nz
+    z0 = palm_grid%z0
 
 
@@ -929,25 +933,25 @@
 !- Section 2: Write global NetCDF attributes
 !------------------------------------------------------------------------------
-       CALL date_and_time(DATE=date_string, TIME=time_string, ZONE=zone_string)
-       history_string =                                                        &
-           'Created on '// date_string      //                                 &
-           ' at '       // time_string(1:2) // ':' // time_string(3:4) //      &
-           ' (UTC'      // zone_string // ')'
-
-       CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'title',          'PALM input file for scenario ...'))
-       CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'institution',    'Deutscher Wetterdienst, Offenbach'))
-       CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'author',         'Eckhard Kadasch, eckhard.kadasch@dwd.de'))
-       CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'history',        TRIM(history_string)))
-       CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'references',     '--'))
-       CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'comment',        '--'))
-       CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'origin_lat',     TRIM(real_to_str(origin_lat*TO_DEGREES, '(F18.13)'))))
-       CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'origin_lon',     TRIM(real_to_str(origin_lon*TO_DEGREES, '(F18.13)'))))
-!
-!--    FIXME: This is the elevation relative to COSMO-DE/D2 sea level and does
-!--    FIXME: not necessarily comply with DHHN2016 (c.f. PALM Input Data
-!--    FIXME: Standard v1.9., origin_z)
-       CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'origin_z',       TRIM(real_to_str(z0, '(F18.13)'))))
-       CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'inifor_version', TRIM(VERSION)))
-       CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'palm_version',   '--'))
+    CALL date_and_time(DATE=date_string, TIME=time_string, ZONE=zone_string)
+    history_string =                                                        &
+        'Created on '// date_string      //                                 &
+        ' at '       // time_string(1:2) // ':' // time_string(3:4) //      &
+        ' (UTC'      // zone_string // ')'
+
+    CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'title',          'PALM input file for scenario ...'))
+    CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'institution',    'Deutscher Wetterdienst, Offenbach'))
+    CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'author',         'Eckhard Kadasch, eckhard.kadasch@dwd.de'))
+    CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'history',        TRIM(history_string)))
+    CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'references',     '--'))
+    CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'comment',        '--'))
+    CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'origin_lat',     TRIM(real_to_str(origin_lat*TO_DEGREES, '(F18.13)'))))
+    CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'origin_lon',     TRIM(real_to_str(origin_lon*TO_DEGREES, '(F18.13)'))))
+!
+!-- FIXME: This is the elevation relative to COSMO-DE/D2 sea level and does
+!-- FIXME: not necessarily comply with DHHN2016 (c.f. PALM Input Data
+!-- FIXME: Standard v1.9., origin_z)
+    CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'origin_z',       TRIM(real_to_str(z0, '(F18.13)'))))
+    CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'inifor_version', TRIM(VERSION)))
+    CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'palm_version',   '--'))
 
 !
@@ -957,47 +961,47 @@
 !------------------------------------------------------------------------------
 !
-!--    reset dimids first
-       dimids = (/0, 0, 0/)
-       CALL check( nf90_def_dim(ncid, "x", nx+1, dimids(1)) )
-       CALL check( nf90_def_dim(ncid, "y", ny+1, dimids(2)) )
-       CALL check( nf90_def_dim(ncid, "z", nz, dimids(3)) )
-!
-!--    save dimids for later
-       output_file % dimids_scl = dimids 
-
-!
-!--    reset dimvarids first
-       dimvarids = (/0, 0, 0/)
-       CALL check(nf90_def_var(ncid, "x", NF90_FLOAT, dimids(1), dimvarids(1)))
-       CALL check(nf90_put_att(ncid, dimvarids(1), "standard_name", "x coordinate of cell centers"))
-       CALL check(nf90_put_att(ncid, dimvarids(1), "units", "m"))
-
-       CALL check(nf90_def_var(ncid, "y", NF90_FLOAT, dimids(2), dimvarids(2)))
-       CALL check(nf90_put_att(ncid, dimvarids(2), "standard_name", "y coordinate of cell centers"))
-       CALL check(nf90_put_att(ncid, dimvarids(2), "units", "m"))
-
-       CALL check(nf90_def_var(ncid, "z", NF90_FLOAT, dimids(3), dimvarids(3)))
-       CALL check(nf90_put_att(ncid, dimvarids(3), "standard_name", "z coordinate of cell centers"))
-       CALL check(nf90_put_att(ncid, dimvarids(3), "units", "m"))
-!
-!--    save dimvarids for later
-       output_file % dimvarids_scl = dimvarids
-
-!
-!--    overwrite third dimid with the one of depth
-       CALL check(nf90_def_dim(ncid, "zsoil", SIZE(palm_grid % depths), dimids(3)) )
-!
-!--    save dimids for later
-       output_file % dimids_soil = dimids
-
-!
-!--    overwrite third dimvarid with the one of depth
-       CALL check(nf90_def_var(ncid, "zsoil", NF90_FLOAT, output_file % dimids_soil(3), dimvarids(3)))
-       CALL check(nf90_put_att(ncid, dimvarids(3), "standard_name", "depth_below_land"))
-       CALL check(nf90_put_att(ncid, dimvarids(3), "positive", "down"))
-       CALL check(nf90_put_att(ncid, dimvarids(3), "units", "m"))
-!
-!--    save dimvarids for later
-       output_file % dimvarids_soil = dimvarids
+!-- reset dimids first
+    dimids = (/0, 0, 0/)
+    CALL check( nf90_def_dim(ncid, "x", nx+1, dimids(1)) )
+    CALL check( nf90_def_dim(ncid, "y", ny+1, dimids(2)) )
+    CALL check( nf90_def_dim(ncid, "z", nz, dimids(3)) )
+!
+!-- save dimids for later
+    output_file%dimids_scl = dimids 
+
+!
+!-- reset dimvarids first
+    dimvarids = (/0, 0, 0/)
+    CALL check(nf90_def_var(ncid, "x", NF90_FLOAT, dimids(1), dimvarids(1)))
+    CALL check(nf90_put_att(ncid, dimvarids(1), "standard_name", "x coordinate of cell centers"))
+    CALL check(nf90_put_att(ncid, dimvarids(1), "units", "m"))
+
+    CALL check(nf90_def_var(ncid, "y", NF90_FLOAT, dimids(2), dimvarids(2)))
+    CALL check(nf90_put_att(ncid, dimvarids(2), "standard_name", "y coordinate of cell centers"))
+    CALL check(nf90_put_att(ncid, dimvarids(2), "units", "m"))
+
+    CALL check(nf90_def_var(ncid, "z", NF90_FLOAT, dimids(3), dimvarids(3)))
+    CALL check(nf90_put_att(ncid, dimvarids(3), "standard_name", "z coordinate of cell centers"))
+    CALL check(nf90_put_att(ncid, dimvarids(3), "units", "m"))
+!
+!-- save dimvarids for later
+    output_file%dimvarids_scl = dimvarids
+
+!
+!-- overwrite third dimid with the one of depth
+    CALL check(nf90_def_dim(ncid, "zsoil", SIZE(palm_grid%depths), dimids(3)) )
+!
+!-- save dimids for later
+    output_file%dimids_soil = dimids
+
+!
+!-- overwrite third dimvarid with the one of depth
+    CALL check(nf90_def_var(ncid, "zsoil", NF90_FLOAT, output_file%dimids_soil(3), dimvarids(3)))
+    CALL check(nf90_put_att(ncid, dimvarids(3), "standard_name", "depth_below_land"))
+    CALL check(nf90_put_att(ncid, dimvarids(3), "positive", "down"))
+    CALL check(nf90_put_att(ncid, dimvarids(3), "units", "m"))
+!
+!-- save dimvarids for later
+    output_file%dimvarids_soil = dimvarids
 !
 !------------------------------------------------------------------------------
@@ -1005,30 +1009,30 @@
 !------------------------------------------------------------------------------
 !
-!--    reset dimids first
-       dimids = (/0, 0, 0/)
-       CALL check(nf90_def_dim(ncid, "xu", nx, dimids(1)) )
-       CALL check(nf90_def_dim(ncid, "yv", ny, dimids(2)) )
-       CALL check(nf90_def_dim(ncid, "zw", nz-1, dimids(3)) )
-!
-!--    save dimids for later
-       output_file % dimids_vel = dimids
-
-!
-!--    reset dimvarids first
-       dimvarids = (/0, 0, 0/)
-       CALL check(nf90_def_var(ncid, "xu", NF90_FLOAT, dimids(1), dimvarids(1)))
-       CALL check(nf90_put_att(ncid, dimvarids(1), "standard_name", "x coordinate of cell faces"))
-       CALL check(nf90_put_att(ncid, dimvarids(1), "units", "m"))
-
-       CALL check(nf90_def_var(ncid, "yv", NF90_FLOAT, dimids(2), dimvarids(2)))
-       CALL check(nf90_put_att(ncid, dimvarids(2), "standard_name", "y coordinate of cell faces"))
-       CALL check(nf90_put_att(ncid, dimvarids(2), "units", "m"))
-
-       CALL check(nf90_def_var(ncid, "zw", NF90_FLOAT, dimids(3), dimvarids(3)))
-       CALL check(nf90_put_att(ncid, dimvarids(3), "standard_name", "z coordinate of cell faces"))
-       CALL check(nf90_put_att(ncid, dimvarids(3), "units", "m"))
-!
-!--    save dimvarids for later
-       output_file % dimvarids_vel = dimvarids
+!-- reset dimids first
+    dimids = (/0, 0, 0/)
+    CALL check(nf90_def_dim(ncid, "xu", nx, dimids(1)) )
+    CALL check(nf90_def_dim(ncid, "yv", ny, dimids(2)) )
+    CALL check(nf90_def_dim(ncid, "zw", nz-1, dimids(3)) )
+!
+!-- save dimids for later
+    output_file%dimids_vel = dimids
+
+!
+!-- reset dimvarids first
+    dimvarids = (/0, 0, 0/)
+    CALL check(nf90_def_var(ncid, "xu", NF90_FLOAT, dimids(1), dimvarids(1)))
+    CALL check(nf90_put_att(ncid, dimvarids(1), "standard_name", "x coordinate of cell faces"))
+    CALL check(nf90_put_att(ncid, dimvarids(1), "units", "m"))
+
+    CALL check(nf90_def_var(ncid, "yv", NF90_FLOAT, dimids(2), dimvarids(2)))
+    CALL check(nf90_put_att(ncid, dimvarids(2), "standard_name", "y coordinate of cell faces"))
+    CALL check(nf90_put_att(ncid, dimvarids(2), "units", "m"))
+
+    CALL check(nf90_def_var(ncid, "zw", NF90_FLOAT, dimids(3), dimvarids(3)))
+    CALL check(nf90_put_att(ncid, dimvarids(3), "standard_name", "z coordinate of cell faces"))
+    CALL check(nf90_put_att(ncid, dimvarids(3), "units", "m"))
+!
+!-- save dimvarids for later
+    output_file%dimvarids_vel = dimvarids
 
 !
